<!-- Main container: Display ad details if 'ad' exists -->
<div *ngIf="ad">
  <mat-card appearance="outlined" class="card-item">

    <!-- Ad headline -->
    <mat-card-title>{{ ad.headline }}</mat-card-title>

    <mat-card-content>

      <!-- Employer and Occupation Details -->
      <h2 *ngIf="ad.employer && ad.employer.name">{{ ad.employer.name }}</h2>
      <h3 *ngIf="ad.occupation && ad.occupation.label">
        <mat-icon>work</mat-icon>&nbsp;{{ ad.occupation.label }}
      </h3>

      <!-- Job specifications (Working Hours, Duration, Employment Type) -->
      <div *ngIf="ad.workingHoursType">
        Omfattning: {{ ad.workingHoursType.label }}
      </div>
      <div *ngIf="ad.duration">
        Varaktighet: {{ ad.duration.label }}
      </div>
      <div *ngIf="ad.employmentType">
        Anställningsform: {{ ad.employmentType.label }}
      </div>

      <!-- Number of Vacancies -->
      <div>Antal tjänster: {{ ad.numberOfVacancies }}</div>

      <!-- Qualifications Section -->
      <h2>Kvalifikationer</h2>
      <ul>
        <li *ngIf="ad.experienceRequired">Arbetserfarenhet krävs</li>
        <li *ngIf="ad.accessToOwnCar">Tillgång till egen bil</li>
        <li *ngIf="ad.drivingLicenseRequired">Körkort krävs</li>
      </ul>

      <!-- Work Experience, Education, Skills, and Languages -->
      <!-- Using helper method 'getRequirementLabel' to display requirement categories -->
      <ng-container *ngFor="let category of ['workExperiences', 'education', 'skills', 'languages']">
        <h3>{{ getRequirementLabel(category) }}</h3>

        <!-- Nice-to-have qualifications -->
        <div *ngIf="ad.niceToHave && ad.niceToHave.workExperiences && ad.niceToHave.workExperiences.length > 0">
          <ul>
            <div *ngFor="let niceToHaveExperience of ad.niceToHave.workExperiences;let i = index">
              <li>{{niceToHaveExperience}} (meriterande)</li>
            </div>
          </ul>
        </div>
        <div *ngIf="ad.mustHave && ad.mustHave.workExperiences && ad.mustHave.workExperiences.length > 0">
          <ul>
            <div *ngFor="let mustHaveExperience of ad.mustHave.workExperiences;let i = index">
              <li>{{mustHaveExperience}} (krav)</li>
            </div>
          </ul>
        </div>
  
      </ng-container>

      <!-- Job Description -->
      <h2>Om jobbet</h2>
      <div *ngIf="ad.description && ad.description.textFormatted" [innerHTML]="ad.description.textFormatted"></div>
      <div *ngIf="ad.description && !ad.description.textFormatted">{{ ad.description.text }}</div>

      <!-- Company Information (optional) -->
      <h2 *ngIf="ad.description && ad.description.companyInformation">Om arbetsgivaren</h2>
      <div *ngIf="ad.description && ad.description.companyInformation">{{ ad.description.companyInformation }}</div>

      <!-- Employment Details -->
      <h2>Om anställningen</h2>
      <div *ngIf="ad.salaryDescription">{{ ad.salaryDescription }}</div>
      <div *ngIf="ad.salaryType">
        Lönetyp: {{ ad.salaryType.label }}
      </div>

      <!-- Workplace Location -->
      <h2>Var ligger arbetsplatsen?</h2>
      <div *ngIf="ad.workplaceAddress">
        <!-- Street Address -->
        <div *ngIf="ad.workplaceAddress.streetAddress">
          <fa-icon [icon]="faLocationDot"></fa-icon> {{ ad.workplaceAddress.streetAddress }}
        </div>
        <!-- Postal Code and City -->
        <div>
          <span *ngIf="ad.workplaceAddress.postcode">{{ ad.workplaceAddress.postcode }} </span>
          <span *ngIf="ad.workplaceAddress.city">{{ ad.workplaceAddress.city }}</span>
        </div>
        <!-- Municipality -->
        <div *ngIf="ad.workplaceAddress.municipality">
          Kommun: {{ ad.workplaceAddress.municipality }}
        </div>
      </div>

      <!-- Employer Information -->
      <h2>Arbetsgivaren</h2>
      <div *ngIf="ad.employer">{{ ad.employer.name }}</div>
      <div *ngIf="ad.employer && ad.employer.url">
        <a href="{{ ad.employer.url | linkHttp }}" target="_blank">{{ ad.employer.url }}</a>
      </div>

      <!-- Ad and Source Details -->
      <div>Id: {{ ad.id }}</div>
      <div>Annons-id: {{ ad.adId }}</div>
      <div>Publiceringsperiod: {{ ad.publicationDate }} - {{ ad.lastPublicationDate }}</div>

      <!-- Source type with conditionals -->
      <div *ngIf="ad.sourceType">
        Annonskälla: {{ getSourceLabel(ad.sourceType) }}
      </div>
      
    </mat-card-content>
    <mat-card-actions></mat-card-actions>
  </mat-card>
</div>
